;;; ej-init.el --- init.d style startup
;;; $Revision: 0.1

;; This file is not part of Emacs

;; Copyright (C) 2011 CyberDomovoy
;; Filename: ej-init.el
;; Version: 0.1
;; Keywords:
;; Author: CyberDomovoy <cd@domovoynet.org>
;; Maintainer: CyberDomovoy <cd@domovoynet.org>
;; Created: 2011-01-09
;; Description: init.d style startup
;; URL:
;; Compatibility: Emacs23


;; COPYRIGHT NOTICE
;;
;; This program is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 2 of the License, or (at your option)
;; any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;; or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
;; for more details. http://www.gnu.org/copyleft/gpl.html
;;

;;; Install:

;; Put this file on your Emacs-Lisp load path, add following into your
;; emacs startup file
;;
;;     (require 'ej-init)
;;
;; Or use autoload and your Emacs starts faster, preferred method:
;;
;;      (autoload 'ej-init "ej-init" "init.d style startup." t)
;;
;; All symbols are prefixed with 'ej-'.
;;

;;; Commentary:

;;  TODO
;;

;;; Change Log:

;;; Code:

;;; .......................................................... require ...

(eval-when-compile (setq byte-compile-dynamic t))

(require 'custom)

;;(eval-and-compile
  ;; We really don't need to load full packages, so use these..
  ;;
;;  )

;;; ............................................................ hooks ...

(defcustom ej-init-load-hooks nil
  "*Hook run when package has been loaded."
  :type 'hook
  :group 'emacs-junkie)

;;; ........................................................... public ...
;;; User configurable variables

;;; .......................................................... version ...

(defconst ej-init-version (substring "$Revision: 0.1 $" 11 15)
  "Version number.")

(defcustom ej-init-dir "~/.emacs.d/rcS.d"
  "*Directory to search for init files"
  :group 'emacs-junkie)


;;; .......................................................... private ...
;;; Private, package's internal variables.

(defconst ej-init-file-name-regex
  "^[0-9]+[-A-Za-z0-9_.]+\.elc?$"
  "Regular expression to select which files to load from `ej-init'.")


;;; .......................................................... macros ...

;;; ........................................................... funcs ...

(defun ej-init ()
  "*Start files in `ej-init-dir'."

  (let
      (
       (files (directory-files (expand-file-name ej-init-dir) t ej-init-file-name-regex))
       (result t)
       )
    (dolist (file files result)
      (setq result (load-file file))
      )
    )
  )


(provide 'ej-init)
(run-hooks 'ej-init-load-hooks)

;;; emacs-junkie.el ends here
