;;; ej-term.el --- ANSI terminal emulator
;;; $Revision: 0.1

;; This file is not part of Emacs

;; Copyright (C) 2011 CyberDomovoy
;; Filename: ej-term.el
;; Version: 0.1
;; Keywords:
;; Author: CyberDomovoy <cd@domovoynet.org>
;; Maintainer: CyberDomovoy <cd@domovoynet.org>
;; Created: 2011-01-09
;; Description: ANSI terminal emulator
;; URL:
;; Compatibility: Emacs23


;; COPYRIGHT NOTICE
;;
;; This program is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the Free
;; Software Foundation; either version 2 of the License, or (at your option)
;; any later version.
;;
;; This program is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
;; or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
;; for more details. http://www.gnu.org/copyleft/gpl.html
;;

;;; Install:

;; Put this file on your Emacs-Lisp load path, add following into your
;; emacs startup file
;;
;;     (require 'ej-term)
;;
;; Or use autoload and your Emacs starts faster, preferred method:
;;
;;      (autoload 'ej-term "ej-term" "" t)
;;
;; All symbols are prefixed with 'ej-'.
;;

;;; Commentary:

;;  TODO
;;

;;; Change Log:

;;; Code:

;;; .......................................................... require ...

(eval-when-compile (setq byte-compile-dynamic t))

(require 'custom)

(eval-and-compile
  ;; We really don't need to load full packages, so use these..
  ;;
  (autoload 'ansi-term "term" "ansi terminal emulator" t)
  )

;;; ............................................................ hooks ...

(defcustom ej-term-load-hooks nil
  "*Hook run when package has been loaded."
  :type 'hook
  :group 'emacs-junkie)

;;; ........................................................... public ...
;;; User configurable variables

;;; .......................................................... version ...

(defconst ej-term-version (substring "$Revision: 0.1 $" 11 15)
  "Version number.")


;;; .......................................................... private ...
;;; Private, package's internal variables.


;;; .......................................................... macros ...

;;; ........................................................... funcs ...

(defun ej-term ()
  "*If buffer *ej-term* exists, switch to it, else run ansi-term."

  (interactive)
  (if (get-buffer "*ej-term*")
      (switch-to-buffer "*ej-term*")
    (ansi-term shell-file-name "ej-term")
    )
  )

(provide 'ej-term)
(run-hooks 'ej-term-load-hooks)

;;; ej-term.el ends here